
use strict;
use warnings;

use Module::Build 0.3601;


my %module_build_args = (
  "build_requires" => {
    "Module::Build" => "0.3601"
  },
  "configure_requires" => {
    "Module::Build" => "0.3601"
  },
  "dist_abstract" => "Fast and featureful data structure validation",
  "dist_author" => [
    "Steven Haryanto <stevenharyanto\@gmail.com>"
  ],
  "dist_name" => "Data-Sah",
  "dist_version" => "0.16",
  "license" => "perl",
  "module_name" => "Data::Sah",
  "recommends" => {},
  "recursive_test_files" => 1,
  "requires" => {
    "Algorithm::Dependency::Ordered" => 0,
    "Algorithm::Dependency::Source::HoA" => 0,
    "Data::Clean::JSON" => 0,
    "Data::ModeMerge" => "0.21",
    "JSON" => 0,
    "Language::Expr" => "0.13",
    "Language::Expr::Interpreter::VarEnumer" => "0.13",
    "Lingua::EN::Numbers::Ordinate" => "1.02",
    "Log::Any" => "0.09",
    "Module::Path" => "0.08",
    "Moo" => 0,
    "Moo::Role" => 0,
    "SHARYANTO::String::Util" => 0,
    "Sub::Install" => 0,
    "Text::sprintfn" => 0,
    "Tie::IxHash" => 0,
    "perl" => "5.010001"
  },
  "script_files" => [],
  "test_requires" => {
    "Capture::Tiny" => 0,
    "Data::Dump::OneLine" => 0,
    "File::ShareDir::Tarball" => 0,
    "File::Slurp" => 0,
    "File::Which" => 0,
    "File::chdir" => 0,
    "Sah" => "v0.9.25",
    "Test::Exception" => 0,
    "Test::More" => "0.98",
    "Test::Warn" => 0,
    "blib" => 0
  }
);


unless ( eval { Module::Build->VERSION(0.4004) } ) {
  my $tr = delete $module_build_args{test_requires};
  my $br = $module_build_args{build_requires};
  for my $mod ( keys %$tr ) {
    if ( exists $br->{$mod} ) {
      $br->{$mod} = $tr->{$mod} if $tr->{$mod} > $br->{$mod};
    }
    else {
      $br->{$mod} = $tr->{$mod};
    }
  }
}

my $build = Module::Build->new(%module_build_args);

$build->create_build_script;
